"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.reactRenderer = void 0;
const react_1 = __importDefault(require("react"));
const api_reference_models_api_node_renderer_1 = require("@teambit/api-reference.models.api-node-renderer");
const api_reference_renderers_api_node_details_1 = require("@teambit/api-reference.renderers.api-node-details");
const api_reference_renderers_parameter_1 = require("@teambit/api-reference.renderers.parameter");
const classnames_1 = __importDefault(require("classnames"));
const semantics_entities_semantic_schema_1 = require("@teambit/semantics.entities.semantic-schema");
const base_react_navigation_link_1 = require("@teambit/base-react.navigation.link");
// @todo - this will be fixed as part of the @teambit/base-react.navigation.link upgrade to latest
const Link = base_react_navigation_link_1.Link;
const react_renderer_module_scss_1 = __importDefault(require("./react.renderer.module.scss"));
exports.reactRenderer = {
    predicate: (node) => node.__schema === 'ReactSchema',
    Component: ReactComponent,
    OverviewComponent: ReactOverviewComponent,
    nodeType: 'React',
    icon: { name: 'React', url: 'https://static.bit.dev/extensions-icons/react.svg' },
    default: true,
};
function ReactComponent(props) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    const { apiNode: { api }, renderers,
    // apiRefModel,
     } = props;
    const reactNode = api;
    const { returnType, props: reactProps, typeParams } = reactNode;
    const returnTypeRenderer = renderers.find((renderer) => renderer.predicate(returnType));
    if ((_b = (_a = props.metadata) === null || _a === void 0 ? void 0 : _a[api.__schema]) === null || _b === void 0 ? void 0 : _b.columnView) {
        return react_1.default.createElement("div", { className: api_reference_models_api_node_renderer_1.nodeStyles.node }, api.toString());
    }
    const paramRenderer = reactProps && renderers.find((renderer) => renderer.predicate(reactProps));
    const paramRef = reactProps === null || reactProps === void 0 ? void 0 : reactProps.type;
    const paramRefRenderer = paramRef && renderers.find((renderer) => renderer.predicate(paramRef));
    const PropsRefComponent = paramRef && (paramRefRenderer === null || paramRefRenderer === void 0 ? void 0 : paramRefRenderer.Component) ? (react_1.default.createElement(paramRefRenderer.Component, Object.assign({ key: `props-ref-${reactProps.name}` }, props, { depth: ((_c = props.depth) !== null && _c !== void 0 ? _c : 0) + 1, apiNode: Object.assign(Object.assign({}, props.apiNode), { renderer: paramRefRenderer, api: paramRef }), metadata: { [paramRef.__schema]: { columnView: true } } }))) : null;
    const ParamComponent = reactProps && (paramRenderer === null || paramRenderer === void 0 ? void 0 : paramRenderer.Component) ? (react_1.default.createElement(paramRenderer.Component, Object.assign({ key: `props-${reactProps.name}` }, props, { depth: ((_d = props.depth) !== null && _d !== void 0 ? _d : 0) + 1, apiNode: Object.assign(Object.assign({}, props.apiNode), { renderer: paramRenderer, api: reactProps }), metadata: { [reactProps.__schema]: { columnView: true } } }))) : ((reactProps && (react_1.default.createElement(api_reference_renderers_parameter_1.parameterRenderer.Component, Object.assign({ key: `props-${reactProps.name}` }, props, { depth: ((_e = props.depth) !== null && _e !== void 0 ? _e : 0) + 1, apiNode: Object.assign(Object.assign({}, props.apiNode), { renderer: api_reference_renderers_parameter_1.parameterRenderer, api: reactProps }), metadata: { [reactProps.__schema]: { columnView: true } } })))) ||
        null);
    const docComment = (_g = (_f = api.doc) === null || _f === void 0 ? void 0 : _f.findTag(semantics_entities_semantic_schema_1.TagName.return)) === null || _g === void 0 ? void 0 : _g.comment;
    return (react_1.default.createElement(api_reference_renderers_api_node_details_1.APINodeDetails, Object.assign({}, props, { options: { hideIndex: true } }),
        typeParams && (react_1.default.createElement("div", { className: (0, classnames_1.default)(react_renderer_module_scss_1.default.container, react_renderer_module_scss_1.default.typeParams, react_renderer_module_scss_1.default.topPad) },
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.title }, "Type Parameters"),
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.values }, typeParams.map((typeParam) => {
                return (react_1.default.createElement("div", { className: (0, classnames_1.default)(react_renderer_module_scss_1.default.value), key: typeParam }, typeParam));
            })))),
        ParamComponent && (react_1.default.createElement("div", { className: (0, classnames_1.default)(react_renderer_module_scss_1.default.container, react_renderer_module_scss_1.default.topPad) },
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.title }, "Props"),
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.paramRef }, PropsRefComponent),
            ParamComponent)),
        react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.container },
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.title }, "Returns"),
            docComment && react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.docComment }, docComment),
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.returnType }, (returnTypeRenderer && (react_1.default.createElement(returnTypeRenderer.Component, Object.assign({}, props, { apiNode: Object.assign(Object.assign({}, props.apiNode), { api: returnType, renderer: returnTypeRenderer }), depth: ((_h = props.depth) !== null && _h !== void 0 ? _h : 0) + 1 })))) || react_1.default.createElement("div", { className: api_reference_models_api_node_renderer_1.nodeStyles.node }, returnType.toString())))));
}
function ReactOverviewComponent(props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    const { apiNode: { api }, renderers,
    // apiRefModel,
     } = props;
    const reactNode = api;
    const { returnType, props: reactProps } = reactNode;
    const returnTypeRenderer = renderers.find((renderer) => renderer.predicate(returnType));
    const paramRenderer = reactProps && renderers.find((renderer) => renderer.predicate(reactProps));
    const paramRef = reactProps === null || reactProps === void 0 ? void 0 : reactProps.type;
    const paramRefRenderer = paramRef && renderers.find((renderer) => renderer.predicate(paramRef));
    const PropsRefComponent = paramRef && (paramRefRenderer === null || paramRefRenderer === void 0 ? void 0 : paramRefRenderer.Component) ? (react_1.default.createElement(paramRefRenderer.Component, Object.assign({ key: `props-ref-${reactProps.name}` }, props, { depth: ((_a = props.depth) !== null && _a !== void 0 ? _a : 0) + 1, apiNode: Object.assign(Object.assign({}, props.apiNode), { renderer: paramRefRenderer, api: paramRef }), metadata: { [paramRef.__schema]: { columnView: true } } }))) : null;
    const ParamComponent = reactProps && (paramRenderer === null || paramRenderer === void 0 ? void 0 : paramRenderer.Component) ? (react_1.default.createElement(paramRenderer.Component, Object.assign({ key: `props-${reactProps.name}` }, props, { depth: ((_b = props.depth) !== null && _b !== void 0 ? _b : 0) + 1, apiNode: Object.assign(Object.assign({}, props.apiNode), { renderer: paramRenderer, api: reactProps }), metadata: { [reactProps.__schema]: { columnView: true } } }))) : ((reactProps && (react_1.default.createElement(api_reference_renderers_parameter_1.parameterRenderer.Component, Object.assign({ key: `props-${reactProps.name}` }, props, { depth: ((_c = props.depth) !== null && _c !== void 0 ? _c : 0) + 1, apiNode: Object.assign(Object.assign({}, props.apiNode), { renderer: api_reference_renderers_parameter_1.parameterRenderer, api: reactProps }), metadata: { [reactProps.__schema]: { columnView: true } } })))) ||
        null);
    const docComment = (_e = (_d = api.doc) === null || _d === void 0 ? void 0 : _d.findTag(semantics_entities_semantic_schema_1.TagName.return)) === null || _e === void 0 ? void 0 : _e.comment;
    const icon = exports.reactRenderer.icon;
    const description = (_g = (_f = api.doc) === null || _f === void 0 ? void 0 : _f.comment) !== null && _g !== void 0 ? _g : (_j = (_h = api === null || api === void 0 ? void 0 : api.doc) === null || _h === void 0 ? void 0 : _h.tags) === null || _j === void 0 ? void 0 : _j.filter((tag) => tag.comment).reduce((acc, tag) => acc.concat(`${tag.comment}\n`), '');
    return (react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.reactOverview },
        react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.reactOverviewHeader },
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.headingLeft },
                icon && (react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.icon },
                    react_1.default.createElement("img", { src: icon.url, alt: icon.name }))),
                react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.title },
                    react_1.default.createElement(Link, { href: `~api-reference?selectedAPI=${api.name}` }, api.name)))),
        description && react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.description }, description),
        ParamComponent && (react_1.default.createElement("div", { className: (0, classnames_1.default)(react_renderer_module_scss_1.default.container, react_renderer_module_scss_1.default.topPad) },
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.title }, "Props"),
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.paramRef }, PropsRefComponent),
            ParamComponent)),
        react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.container },
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.title }, "Returns"),
            docComment && react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.docComment }, docComment),
            react_1.default.createElement("div", { className: react_renderer_module_scss_1.default.returnType }, (returnTypeRenderer && (react_1.default.createElement(returnTypeRenderer.Component, Object.assign({}, props, { apiNode: Object.assign(Object.assign({}, props.apiNode), { api: returnType, renderer: returnTypeRenderer }), depth: ((_k = props.depth) !== null && _k !== void 0 ? _k : 0) + 1 })))) || react_1.default.createElement("div", { className: api_reference_models_api_node_renderer_1.nodeStyles.node }, returnType.toString())))));
}
//# sourceMappingURL=react.renderer.js.map